package gkdtree;

/**
 *
 * Static methods for a mapping between linear and n-dimensional indices.
 * 
 * @author DarkMatt
 *
 */

public class LinearNDMapping {

	public static int[] toNDimensional(int dimension, int[] data_size, int linear) {
		
		int[] out = new int[dimension];
		for (int i=0; i<dimension; i++) {
			int size_div = 1;
			for (int j=0; j<i; j++) {
				size_div *= data_size[j];
			}
			int tmp_linear = linear/size_div;
			out[i] = tmp_linear%data_size[i];
		}
		
		return out;
	}
	
	public static int toLinear(int dimension, int[] data_size, int[] nDimensional) {
		
		int lin_index = 0;
		for (int i=0; i<dimension; i++) {
			int size_mult = 1;
			for (int j=0; j<i; j++) {
				size_mult *= data_size[j];
			}
			lin_index += size_mult * nDimensional[i];
		}
		
		return lin_index;
	}
	
}
