package rendertools;

/**
 *
 * Static finding of maximal/minimal values.
 * 
 * @author DarkMatt
 *
 */

public class Extremum {

	public static float[] getMinMax(float[] vertex_data, int start, int size, boolean quads) {
		
		float[] out = new float[]{	Float.MAX_VALUE, -Float.MAX_VALUE, 	//x
									Float.MAX_VALUE, -Float.MAX_VALUE, 	//y
									Float.MAX_VALUE, -Float.MAX_VALUE};	//z
		
		if (!quads) { 	//default
			
			for (int i=start; i<start+size; i+=9) { //REALLY NEEDED?
				for (int v=0; v<3; v++) {
					if (vertex_data[i+3*v] 	<out[0]) out[0] = vertex_data[i+3*v];
					if (vertex_data[i+3*v]	>out[1]) out[1] = vertex_data[i+3*v];
					if (vertex_data[i+3*v+1]<out[2]) out[2] = vertex_data[i+3*v+1];
					if (vertex_data[i+3*v+1]>out[3]) out[3] = vertex_data[i+3*v+1];
					if (vertex_data[i+3*v+2]<out[4]) out[4] = vertex_data[i+3*v+2];
					if (vertex_data[i+3*v+2]>out[5]) out[5] = vertex_data[i+3*v+2];
				}
			}
			
		} else { 		//for the second triangle of a quad
			
			//first 2 verts
			for (int v=2; v<4; v++) {
				if (vertex_data[3*v] 	< out[0]) out[0] = vertex_data[3*v];
				if (vertex_data[3*v]	> out[1]) out[1] = vertex_data[3*v];
				if (vertex_data[3*v+1]	< out[2]) out[2] = vertex_data[3*v+1];
				if (vertex_data[3*v+1]	> out[3]) out[3] = vertex_data[3*v+1];
				if (vertex_data[3*v+2]	< out[4]) out[4] = vertex_data[3*v+2];
				if (vertex_data[3*v+2]	> out[5]) out[5] = vertex_data[3*v+2];
			}
			//last vertex
			if (vertex_data[0] 	< out[0]) out[0] = vertex_data[0];
			if (vertex_data[0]	> out[1]) out[1] = vertex_data[0];
			if (vertex_data[1]	< out[2]) out[2] = vertex_data[1];
			if (vertex_data[1]	> out[3]) out[3] = vertex_data[1];
			if (vertex_data[2]	< out[4]) out[4] = vertex_data[2];
			if (vertex_data[2]	> out[5]) out[5] = vertex_data[2];
			
		}
		
		return out;
	}
	
}
